// Pain Stacks
// by MissEshock2002

// This script, from https://ss.deviatenow.com, is protected by this licence :
// CC by-NC, see http://creativecommons.org/licenses/by-nc/3.0/

setInfos(9, "Pain Stacks", "Get shocked, till the stacks are full! (requires Shock Yourself)",
        "MissEshock2002",
        "v0.8", 0x222222, "en", ["estim", "electro", "formale", "forfemale", "pain", "punishment"]);


/*
 TODO select glitches
 TODO two configs for game modes?
*/

String SCRIPTNAME = "PainStacks"

boolean DEBUG = loadBoolean(SCRIPTNAME + ".DEBUG") // PainStacks.DEBUG=true

Map GLITCHES_CLASSIC = [
        "shock_not_count"       : "Shock Not Count",
        "flush_stack"           : "Flush Stack",
        "flush_highest_stacks"  : "Flush Highest Stacks",
        "add_stack"             : "Add Stack",
        "add_glitches"          : "Add Glitches",
        "lower_all_one"         : "Lower All Stacks By One",
        "random_painlevel"      : "Random Pain Level",
        "random_shocktime"      : "Random Shock Time",
        "random_shocknumber"    : "Random Shock Number",
        "repeat_stack"          : "Repeat Stack",
        "repeat_stack_backwards": "Repeat Stack Backwards",
        "stack_up"              : "Stack up"
]

Map GLITCHES_RETRO = [
        "shock_not_count"       : "Shock Not Count",
        "fill_stack"            : "Fill Stack",
        "increase_all_by_one"   : "Increase All Stacks By One",
        "increase_random_stacks": "Increase Random Stacks",
        "add_glitches"          : "Add Glitches",
        "random_painlevel"      : "Random Pain Level",
        "random_shocktime"      : "Random Shock Time",
        "random_shocknumber"    : "Random Shock Number",
        "random_wait_time"      : "Random Wait Time",
]

// defaults
String SOUNDSDIR = "ShockYourself/"
String EXT = ".wav"
List<String> ESTIMFILENAMES = [
        "burst_sawtooth_100hz_10sec_level",
        "burst_square_100hz_10sec_level",
        "sawtooth_100hz_10sec_level",
        "square_100hz_10sec_level"
]
List<String> SHOCKTYPES = ["single", "sequence"]

List<Integer> PAINLEVELRANGELIMIT = [1, 20]
List<Float> SHOCKTIMERANGELIMIT = [1.0, 60.0]

List<Integer> PAINLEVELRANGE = [2, 20, 2] // start, stop, step
List<Float> SHOCKTIMERANGE = [1.8, 3.6]
List<Integer> WAITTIMERANGE = [15, 60] // [90, 180]
int NUMSTACKS = 6
int MAXSTACKS = 24
int CHANCEDELAYMAXSHOCK = 20
List<Integer> GLITCHESRANGE = [0, 0]
int NUMSTACKSTOFILL = 1
int NUMSHOCKSTODO = 30
int UNFAIRPICKCHANCE = 0
int MAXUNFAIRPICKCHANCE = 10

boolean PAINLEVELRANDOM = false
boolean SHOCKTIMERANDOM = false
boolean WAITTIMERANDOM = false
boolean PAINLEVELHIDDEN = false


int numStacks
int chanceDelayMaxShock
List stacks = []
List<Integer> painLevelRange = []
List<Float> shockTimeRange = []
List<Float> waitTimeRange = []
List<Integer> glitchesRange = []
List<String> estimFileNames = []
boolean glitchesVisible = false
int numStacksToFill = NUMSTACKSTOFILL
int stacksFull = 0
int numShocksToDo = NUMSHOCKSTODO
boolean openCDTray
int countDownMin // in minutes
int countDownSec // in seconds
boolean retroGameMode = false
int painLevel
float shockTime
float waitTime
String shockType

boolean painLevelRandom = PAINLEVELRANDOM
boolean shockTimeRandom = SHOCKTIMERANDOM
boolean waitTimeRandom = WAITTIMERANDOM
boolean painLevelHidden = PAINLEVELHIDDEN


int minPainLevel
int maxPainLevel
int painLevelStep
float deltaPainLevel
float deltaShockTime
float deltaWaitTime
boolean canStopShock = true
// item = [done, painLevel, shockTime, waitTime, glitch]
int stackItemSize = 5
int itemIndexDone = 0
int itemIndexPainLevel = 1
int itemIndexShockTime = 2
int itemIndexWaitTime = 3
int itemIndexGlitches = 4

// graphics
// color gradient
float deltaColor = 255.0 / 10
List<List> COLOR_GRADIENT = []
for (int i = 0; i < 10; i++) {
    int red = (int) Math.round(i * deltaColor)
    COLOR_GRADIENT.add([red, 200, 0])
}
for (int i = 1; i <= 10; i++) {
    int green = 255 - (int) Math.round(i * deltaColor)
    COLOR_GRADIENT.add([255, green, 0])
}

java.awt.Image hiddenImage = javax.imageio.ImageIO.read(new File("images/" + SCRIPTNAME + "/hidden.png"))
java.awt.Image frameImage = javax.imageio.ImageIO.read(new File("images/" + SCRIPTNAME + "/frame.png"))
Map numberImages = [:]
for (int n = 1; n <= 20; n++) {
    def pathName = String.format("images/" + SCRIPTNAME + "/%s.png", n)
    java.awt.Image img = javax.imageio.ImageIO.read(new File(pathName))
    numberImages[n] = img
}
//java.awt.Color colorBG = new java.awt.Color(24, 24, 24, 0)
//java.awt.Color colorGrey = new java.awt.Color(96, 96, 96)
java.awt.Color colorWhite = new java.awt.Color(255, 255, 255)
java.awt.Color glitchesColor = new java.awt.Color(200, 0, 255)
int rectSizeX = frameImage.getWidth()
int rectSizeY = frameImage.getHeight()
int rectBorder = (int) rectSizeX / 50 // 100px wide with 2px border
int borderX = (int) (rectSizeX / 2)
int borderY = (int) (rectSizeX / 2)
int marginX = (int) (rectSizeX / 4)
int marginY = 0
int width
int height
java.awt.image.BufferedImage frameBuffer
java.awt.Graphics graphics


def initGraphics = {
    int stack_hight = stacks[0].size()
    stacks.each { st ->
        if (st.size() > stack_hight) stack_hight = st.size()
    }
    def resize = {
        width = 2 * borderX + stacks.size() * rectSizeX + (stacks.size() - 1) * marginX
        height = 2 * borderY + stack_hight * rectSizeY + (stack_hight - 1) * marginY
    }
    resize()
    while (width > 2000) {
        rectSizeX = (int) (rectSizeX / 2)
        rectSizeY = (int) (rectSizeY / 2)
        marginX = (int) (rectSizeX / 4)
        resize()
    }
    frameBuffer = new java.awt.image.BufferedImage(width, height, java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
    graphics = frameBuffer.createGraphics()
}

def drawStacks = {
    for (int col = (stacks.size() - 1); col >= 0; col--) {
        for (int row = 0; row < stacks[col].size(); row++) {
            int plvl = stacks[col][row][itemIndexPainLevel]
            java.awt.Color color = colorWhite
            if (stacks[col][row][itemIndexDone]) {
                if (stacks[col][row][itemIndexGlitches] && glitchesVisible) color = glitchesColor
                else {
                    int gradIndex = plvl - 1
                    int red = COLOR_GRADIENT[gradIndex][0]
                    int green = COLOR_GRADIENT[gradIndex][1]
                    int blue = COLOR_GRADIENT[gradIndex][2]
                    color = new java.awt.Color(red, green, blue)
                }
            } else if (DEBUG) {
                if (stacks[col][row][itemIndexGlitches]) color = glitchesColor.darker()
            }
            graphics.setColor(color)
            def x_new = col * (rectSizeX + marginX) + borderX
            def y_new = -row * (rectSizeY + marginY) - 2 * borderY + height - rectBorder
            graphics.fillRect(x_new, y_new, rectSizeX, rectSizeY)
            if (painLevelHidden && !stacks[col][row][itemIndexDone])
                graphics.drawImage(hiddenImage, x_new, y_new, rectSizeX, (rectSizeY + rectBorder), null)
            else
                graphics.drawImage(numberImages[plvl], x_new, y_new, rectSizeX, (rectSizeY + rectBorder), null)
            graphics.drawImage(frameImage, x_new, y_new, rectSizeX, (rectSizeY + rectBorder), null)
        }
    }
    java.io.ByteArrayOutputStream outputStream = new java.io.ByteArrayOutputStream()
    javax.imageio.ImageIO.write(frameBuffer, "png", outputStream)
    setImage(outputStream.toByteArray(), 0)
}


def getEstimFileNames = {
    List<String> fileNames = []
    List<String> uniqueNames = []
    File dir = new File("sounds/" + SOUNDSDIR)
    try {
        dir.traverse(type: groovy.io.FileType.FILES, maxDepth: 0) { file ->
            if (file.name.endsWith(EXT)) fileNames.add(file.name)
            String name = file.name.split('\\.')[0]

            List find = name.findAll('\\d+$')
            if (!find.isEmpty()) {
                if (find[0].isNumber()) {
                    String uName = name.replaceAll('\\d+$', '')
                    if (!(uName in uniqueNames)) uniqueNames.add(uName)
                }
            }
        }
        List<String> missingNames = []
        uniqueNames.each { uName ->
            for (int lvl = PAINLEVELRANGELIMIT.min(); lvl <= PAINLEVELRANGELIMIT.max(); lvl++) {
                String name = uName + lvl + EXT
                if (!(name in fileNames)) {
                    if (!(uName in missingNames)) missingNames.add(name)
                }
            }
        }
        if (!missingNames.isEmpty()) {
            show("ERROR! Missing sound files: " + missingNames)
            showButton("Quit")
            exit()
        }
        Collections.sort(uniqueNames)
        return uniqueNames
    } catch (Exception e) {
        show("ERROR! 'Shock Yourself' not installed?")
        showButton("Quit")
        exit()
    }

}

def getRandomEstimFileName = { return estimFileNames[getRandom(estimFileNames.size())] }

def playShockSingle = { stime, plvl, boolean canStop = false, float stopAppearTime = 0.0, float stopDisappearTime = 0.0 ->
    String sound = SOUNDSDIR + getRandomEstimFileName() + plvl + EXT
    int repetitions = (int) Math.ceil(stime / 10)
    try {
        playBackgroundSound(sound, repetitions)
        if (canStop) {
            wait(stopAppearTime)
            if ((stime - stopAppearTime) != showButton("STOP SHOCK", (stime - stopAppearTime))) {
                playBackgroundSound(null)
                return true // true = stopped
            }
        } else wait(stime)
        playBackgroundSound(null)
        return false
    }
    catch (Exception e) {
        playBackgroundSound(null)
        openCdTrays()
        show("Error! Sound file missing?")
        showButton("Quit")
        exit()
    }
}

def playShockSequence = { stime, plvl, boolean canStop = false, float stopAppearTime = 0.0, float stopDisappearTime = 0.0 ->
    def shockSequence = []
    if (stime <= 2 * SHOCKTIMERANGELIMIT.min()) {
        shockSequence = [stime]
    } else {
        while (shockSequence.sum() < stime) {
            float rndTime = 1.2 * SHOCKTIMERANGELIMIT.min() - getRandom(5) / 10
            shockSequence.add(rndTime)
        }
        while (shockSequence.sum() > stime) {
            shockSequence.remove(0)
        }
        shockSequence[-1] = shockSequence[-1] + (stime - shockSequence.sum())
    }
    for (int i = 0; i < shockSequence.size(); i++) {
        stime = shockSequence[i]
        String sound = SOUNDSDIR + getRandomEstimFileName() + plvl + EXT
        try {
            playBackgroundSound(sound)
            if (canStop) {
                wait(stopAppearTime)
                if ((stime - stopAppearTime) != showButton("STOP SHOCK", (stime - stopAppearTime))) {
                    playBackgroundSound(null)
                    return true // true = stopped
                }
            } else wait(stime)
            playBackgroundSound(null)
        }
        catch (Exception e) {
            playBackgroundSound(null)
            openCdTrays()
            show("Error! Sound file missing?")
            showButton("Quit")
            exit()
        }
    }
    return false // false = not stopped
}

def shock = { stime, plvl, boolean canStop = false, float stopAppearTime = 0.0, float stopDisappearTime = 0.0 ->
    if (shockType == "single") return playShockSingle(stime, plvl, canStop, stopAppearTime, stopDisappearTime)
    else if (shockType == "sequence") return playShockSequence(stime, plvl, canStop, stopAppearTime, stopDisappearTime)
}

def testEstim = {
    String sound = ""
    int estimIndex = 0
    List<String> testEstimFileNames = getEstimFileNames()
    float stime = 1.0
    int testPainLevel = PAINLEVELRANGELIMIT[1]
    List eggQ = []
    while (true) {
        String txt = "Make sure no other audio sources will play!\n" +
                "Setup your your eStim device properly!\n" +
                "\n<b>WARNING!\nPressing 'TEST' will play an eStim audio file immediately for 1 second!</b>" +
                "\n\n<span style='font-size: 12px';')>audio files:\n"
        for (int i = 0; i < testEstimFileNames.size(); i++) {
            if (i == estimIndex) txt += "<b>" + testEstimFileNames[i] + ".wav</b>\n"
            else txt += testEstimFileNames[i] + ".wav\n"
        }
        txt += "</span>"

        int menu = getSelectedValue(txt, ["End Test",
                                          "Cycle",
                                          "Pain Level +1",
                                          "Pain Level -1",
                                          "TEST Pain Level " + testPainLevel,
        ])
        if (menu == 0) break
        if (menu == 1) estimIndex = (estimIndex + 1) % testEstimFileNames.size()
        if (menu == 2) if (testPainLevel < PAINLEVELRANGELIMIT[1]) testPainLevel++
        if (menu == 3) if (testPainLevel > PAINLEVELRANGELIMIT[0]) testPainLevel--
        if (menu == 4) {
            sound = SOUNDSDIR + testEstimFileNames[estimIndex] + testPainLevel + EXT
            playBackgroundSound(sound)
            if (stime != showButton("STOP!", stime)) playBackgroundSound(null)
            playBackgroundSound(null)
            eggQ.add(testPainLevel)
            if (eggQ == [6, 9, 6, 9]) {
                UNFAIRPICKCHANCE = 69
                show("playing 69% unfair in Retro Game Mode = chance to pick highest pain level 69%")
                showButton("->")
                break
            }
        }
    }
}


def resetDefault = {
    numStacks = NUMSTACKS
    numShocksToDo = NUMSHOCKSTODO
    chanceDelayMaxShock = CHANCEDELAYMAXSHOCK
    painLevelRange = PAINLEVELRANGE
    shockTimeRange = SHOCKTIMERANGE
    waitTimeRange = WAITTIMERANGE
    estimFileNames = ESTIMFILENAMES
    glitchesRange = GLITCHESRANGE
    painLevelRandom = PAINLEVELRANDOM
    shockTimeRandom = SHOCKTIMERANDOM
    waitTimeRandom = WAITTIMERANDOM
    painLevelHidden = PAINLEVELHIDDEN
    shockType = SHOCKTYPES[0]
}

def loadConfig = {
    numStacks = loadInteger(SCRIPTNAME + ".numStacks")
    chanceDelayMaxShock = loadInteger(SCRIPTNAME + ".chanceDelayMaxShock")
    painLevelRandom = loadBoolean(SCRIPTNAME + ".painLevelRandom")
    shockTimeRandom = loadBoolean(SCRIPTNAME + ".shockTimeRandom")
    waitTimeRandom = loadBoolean(SCRIPTNAME + ".waitTimeRandom")
    painLevelHidden = loadBoolean(SCRIPTNAME + ".painLevelHidden")

    painLevelRange.clear()
    shockTimeRange.clear()
    waitTimeRange.clear()
    glitchesRange.clear()
    for (int i = 0; i <= 2; i++) {
        painLevelRange.add(loadInteger(SCRIPTNAME + ".painLevelRange." + i))
    }
    for (int i = 0; i <= 1; i++) {
        shockTimeRange.add(loadFloat(SCRIPTNAME + ".shockTimeRange." + i))
        waitTimeRange.add(loadFloat(SCRIPTNAME + ".waitTimeRange." + i))
        glitchesRange.add(loadInteger(SCRIPTNAME + ".glitchesRange." + i))
    }

    List<String> estimNames = getEstimFileNames()
    if (estimNames.isEmpty()) {
        show("Error! Sound file missing?")
        showButton("Quit")
    }
    estimNames.eachWithIndex { String fileName, int i ->
        String estimName = loadString(SCRIPTNAME + ".estimFileNames." + i)
        if (estimName in estimNames) estimFileNames.add(estimName)
    }
    if (estimFileNames.isEmpty()) estimFileNames = estimNames

    shockType = loadString(SCRIPTNAME + ".shockType")

    if (numStacks == null) numStacks = NUMSTACKS
    if (chanceDelayMaxShock == null) chanceDelayMaxShock = CHANCEDELAYMAXSHOCK
    if (painLevelRandom == null) painLevelRandom = PAINLEVELRANDOM
    if (shockTimeRandom == null) shockTimeRandom = SHOCKTIMERANDOM
    if (waitTimeRandom == null) waitTimeRandom = WAITTIMERANDOM
    if (painLevelHidden == null) painLevelHidden = PAINLEVELHIDDEN
    if (painLevelRange.any { e -> e == null }) painLevelRange = PAINLEVELRANGE
    if (shockTimeRange.any { e -> e == null }) shockTimeRange = SHOCKTIMERANGE
    if (waitTimeRange.any { e -> e == null }) waitTimeRange = WAITTIMERANGE
    if (glitchesRange.any { e -> e == null }) glitchesRange = GLITCHESRANGE
    if (shockType == null) shockType = SHOCKTYPES[0]
}

def saveConfig = {
    save(SCRIPTNAME + ".numStacks", numStacks)
    save(SCRIPTNAME + ".chanceDelayMaxShock", chanceDelayMaxShock)
    save(SCRIPTNAME + ".painLevelRange", painLevelRange)
    save(SCRIPTNAME + ".shockTimeRange", shockTimeRange)
    save(SCRIPTNAME + ".waitTimeRange", waitTimeRange)
    save(SCRIPTNAME + ".glitchesRange", glitchesRange)
    save(SCRIPTNAME + ".estimFileNames", estimFileNames)
    save(SCRIPTNAME + ".painLevelRandom", painLevelRandom)
    save(SCRIPTNAME + ".shockTimeRandom", shockTimeRandom)
    save(SCRIPTNAME + ".waitTimeRandom", waitTimeRandom)
    save(SCRIPTNAME + ".painLevelHidden", painLevelHidden)
    save(SCRIPTNAME + ".shockType", shockType)
}


def getNewStackItem = { pLevel, sTime, wTime ->
    // item = [done, painLevel, shockTime, waitTime, glitch]
    List item = [null] * stackItemSize
    item[itemIndexDone] = false
    item[itemIndexPainLevel] = pLevel
    item[itemIndexShockTime] = sTime
    item[itemIndexWaitTime] = wTime
    item[itemIndexGlitches] = null
    return item
}

def getNewStack = {
    minPainLevel = painLevelRange[0]
    maxPainLevel = painLevelRange[1]
    painLevelStep = painLevelRange[2]

    deltaPainLevel = 0
    deltaShockTime = 0
    deltaWaitTime = 0

    if ((maxPainLevel - minPainLevel) != 0) {
        deltaPainLevel = (maxPainLevel - minPainLevel)
        deltaShockTime = (shockTimeRange[1] - shockTimeRange[0]) / deltaPainLevel
        deltaWaitTime = (waitTimeRange[1] - waitTimeRange[0]) / deltaPainLevel
    }

    List painLevels = []
    List shockTimes = []
    List waitTimes = []

    for (int i = 0; i <= (maxPainLevel - minPainLevel); i += painLevelStep) {
        if (painLevelRandom) painLevel = minPainLevel + getRandom(maxPainLevel - minPainLevel + 1)
        else painLevel = i + minPainLevel
        painLevels.add(painLevel)

        if (shockTimeRandom) shockTime = shockTimeRange.min() + getRandom((int) ((shockTimeRange.max() - shockTimeRange.min()) * 10)) / 10
        else shockTime = (float) Math.round(i * deltaShockTime * 10) / 10 + shockTimeRange[0]
        shockTimes.add(shockTime)

        if (waitTimeRandom) waitTime = waitTimeRange.min() + getRandom((int) ((waitTimeRange.max() - waitTimeRange.min()) * 10)) / 10
        else waitTime = (float) Math.round(i * deltaWaitTime * 100) / 100 + waitTimeRange[0]
        waitTimes.add(waitTime)
    }

    List stack = []
    painLevels.eachWithIndex { int plvl, int idx ->
        def newStack = getNewStackItem(painLevels[idx], shockTimes[idx], waitTimes[idx])
        stack.add(newStack)
    }

    return stack
}

def initGame = {
    stacks.clear()
    for (int n = 0; n < numStacks; n++) {
        stacks.add(getNewStack())
    }

    if (retroGameMode) {
        // set first row = true
        stacks.each { st ->
            st[0][0] = true
        }
    }

    // glitches
    Map glitches
    if (retroGameMode) glitches = GLITCHES_RETRO
    else glitches = GLITCHES_CLASSIC
    List rndStackPos = []
    for (int row = (stacks[0].size() - 1); row >= 0; row--) {
        for (int col = 0; col < stacks.size(); col++) {
            rndStackPos.add([col, row])
        }
    }
    Collections.shuffle(rndStackPos)
    int numGlitches = getRandom((glitchesRange.max() - glitchesRange.min() + 1)) + glitchesRange.min()

    if (numGlitches > rndStackPos.size()) numGlitches = rndStackPos.size()
    for (int gl = 0; gl < numGlitches; gl++) {
        int col = rndStackPos[gl][0]
        int row = rndStackPos[gl][1]
        stacks[col][row][itemIndexGlitches] = glitches.keySet()[getRandom(glitches.size())]
    }

    initGraphics()
}


def getParameterTextClassic = {
    String cfgtxt
    cfgtxt = "<p style='font-family:monospace;font-size:12px;'>" +
            "Number of Stacks ........ " + numStacks + "\n" +
            "Pain levels ............. " + painLevelRange[0] + " to " + painLevelRange[1] + " with step " + painLevelRange[2] + "\n" +
            "Shock time .............. " + shockTimeRange[0] + " to " + shockTimeRange[1] + " seconds\n" +
            "Wait time ............... " + waitTimeRange[0] + " to " + waitTimeRange[1] + " seconds\n" +
            "Shock Type .............. " + shockType + "\n" +
            "Pain level random ....... " + painLevelRandom + "\n" +
            "Shock time random ....... " + shockTimeRandom + "\n" +
            "Wait time random ........ " + waitTimeRandom + "\n" +
            "Pain hevel hidden ....... " + painLevelHidden + "\n" +
            "Chance delay max Shocks . " + chanceDelayMaxShock + "%\n" +
            "Number of Glitches ...... " + glitchesRange[0] + " to " + glitchesRange[1] + "\n"
    "</p>"
    return cfgtxt
}

def getParameterTextRetro = {
    String cfgtxt
    cfgtxt = "<p style='font-family:monospace;font-size:12px;'>" +
            "Number of Stacks ........ " + numStacks + "\n" +
            "Pain levels ............. " + painLevelRange[0] + " to " + painLevelRange[1] + " with step " + painLevelRange[2] + "\n" +
            "Shock time .............. " + shockTimeRange[0] + " to " + shockTimeRange[1] + " seconds\n" +
            "Wait time ............... " + waitTimeRange[0] + " to " + waitTimeRange[1] + " seconds\n" +
            "Shock Type .............. " + shockType + "\n" +
            "Pain level random ....... " + painLevelRandom + "\n" +
            "Shock time random ....... " + shockTimeRandom + "\n" +
            "Wait time random ........ " + waitTimeRandom + "\n" +
            "Pain hevel hidden ....... " + painLevelHidden + "\n" +
            "Number of Glitches ...... " + glitchesRange[0] + " to " + glitchesRange[1] + "\n" +
            "</p>"
    return cfgtxt
}

def changeConfig = {
    String txt

    def changeNumStacks = {
        while (true) {
            txt = "Default number of Stacks (max. " + MAXSTACKS + ")"
            numStacks = getInteger(txt, numStacks)
            if (numStacks > 0 && numStacks <= MAXSTACKS) break
            if (numStacks > MAXSTACKS) numStacks = MAXSTACKS
        }
    }

    def changePainLevelRange = {
        while (true) {
            List<Integer> painLevelList = []
            for (int i = 0; i <= (painLevelRange[1] - painLevelRange[0]); i += painLevelRange[2]) {
                painLevelList.add(i + painLevelRange[0])
            }

            String rangeText = painLevelRange[0] + "-" + painLevelRange[1] + ";" + painLevelRange[2]
            txt = "Set the pain level range from " + PAINLEVELRANGELIMIT.min() + " to " + PAINLEVELRANGELIMIT.max() + " and step size." +
                    "\nThe pain levels set the stack height." +
                    "\n\ncurrent range: " + rangeText + " (start-stop;step)" +
                    "\n\n" + painLevelList.toString() + // .replaceAll('\\[|\\]', '') +
                    "\n\n<b>Warning! Pain difference can be huge!</b>"
            String strRange = getString(txt, rangeText)
            if (strRange.indexOf('-') >= 0) {
                List range = strRange.split('-|;').collect()
                if (range.size() == 3) {
                    def min = range[0]
                    def max = range[1]
                    def step = range[2]
                    if (min.isInteger() && max.isInteger()) {
                        min = min.toInteger()
                        max = max.toInteger()
                        step = step.toInteger()
                        if (
                        min <= max &&
                                min >= PAINLEVELRANGELIMIT[0] && min <= PAINLEVELRANGELIMIT[1] &&
                                max >= PAINLEVELRANGELIMIT[0] && max <= PAINLEVELRANGELIMIT[1] &&
                                step >= 1 &&
                                step <= PAINLEVELRANGELIMIT[1]) {
                            painLevelRange[0] = min
                            painLevelRange[1] = max
                            painLevelRange[2] = step
                            break
                        }
                    }
                }
            }
        }
    }

    def changeShockTimeRange = {
        while (true) {

            List<Integer> shockTimeList = []
            deltaPainLevel = (painLevelRange[1] - painLevelRange[0])
            deltaShockTime = (shockTimeRange[1] - shockTimeRange[0]) / deltaPainLevel
            for (int i = 0; i <= (painLevelRange[1] - painLevelRange[0]); i += painLevelRange[2]) {
                shockTimeList.add((float) Math.round(i * deltaShockTime * 100) / 100 + shockTimeRange[0])
            }

            String rangeText = shockTimeRange[0] + "-" + shockTimeRange[1]
            txt = "Set the range how long a single shock will run." +
                    "\n\ncurrent range: " + rangeText +
                    "\n\nmaximum is " + SHOCKTIMERANGELIMIT[1] +
                    "\n\n" + shockTimeList
            String strRange = getString(txt, rangeText)
            if (strRange.indexOf('-') >= 0) {
                List range = strRange.split('-').collect()
                if (range.size() == 2) {
                    def min = range[0]
                    def max = range[1]
                    if (min.isFloat() && max.isFloat()) {
                        min = min.toFloat()
                        max = max.toFloat()
                        if (min >= SHOCKTIMERANGELIMIT[0] && min <= SHOCKTIMERANGELIMIT[1] &&
                                max >= SHOCKTIMERANGELIMIT[0] && max <= SHOCKTIMERANGELIMIT[1]) {
                            shockTimeRange[0] = min
                            shockTimeRange[1] = max
                            break
                        }
                    }
                }
            }
        }
    }

    def changeWaitTimeRange = {
        while (true) {

            List<Integer> waitTimeList = []
            deltaPainLevel = (painLevelRange[1] - painLevelRange[0])
            deltaWaitTime = (waitTimeRange[1] - waitTimeRange[0]) / deltaPainLevel
            for (int i = 0; i <= (painLevelRange[1] - painLevelRange[0]); i += painLevelRange[2]) {
                waitTimeList.add((float) Math.round(i * deltaWaitTime * 100) / 100 + waitTimeRange[0])
            }

            String rangeText = waitTimeRange[0] + "-" + waitTimeRange[1]
            txt = "Set the range how long a pause between shocks will be." +
                    "\n\ncurrent range: " + rangeText +
                    "\n\n" + waitTimeList
            String strRange = getString(txt, rangeText)
            if (strRange.indexOf('-') >= 0) {
                List range = strRange.split('-').collect()
                if (range.size() == 2) {
                    def min = range[0]
                    def max = range[1]
                    if (min.isFloat() && max.isFloat()) {
                        min = min.toFloat()
                        max = max.toFloat()
                        if (min >= 0 && max >= 0) {
                            waitTimeRange[0] = min
                            waitTimeRange[1] = max
                            break
                        }
                    }
                }
            }
        }
    }

    def changePainLevelRandom = {
        while (true) {
            txt = "Random pain levels (default: " + PAINLEVELRANDOM + ")"
            painLevelRandom = getBoolean(txt)
            break
        }
    }

    def changeShockTimeRandom = {
        while (true) {
            txt = "Random shock times (default: " + SHOCKTIMERANDOM + ")"
            shockTimeRandom = getBoolean(txt)
            break
        }
    }

    def changeWaitTimeRandom = {
        while (true) {
            txt = "Random wait times (default: " + WAITTIMERANDOM + ")"
            waitTimeRandom = getBoolean(txt)
            break
        }
    }

    def changePainLevelHidden = {
        while (true) {
            txt = "Hide pain levels (default: " + PAINLEVELHIDDEN + ")"
            painLevelHidden = getBoolean(txt)
            break
        }
    }

    def changeChanceDelayMaxShock = {
        while (true) {
            txt = "Chance to delay max Shocks"
            chanceDelayMaxShock = getInteger(txt, chanceDelayMaxShock)
            if (chanceDelayMaxShock >= 0 || chanceDelayMaxShock <= 100) break
        }
    }

    def changeEstimFileNames = {
        while (true) {
            List estimNames = getEstimFileNames()
            List checkBox = [false] * estimNames.size()
            int i = 0
            estimNames.each { e ->
                if (e in estimFileNames) checkBox[i] = true
                i++
            }
            checkBox = getBooleans("eStim sound files:", estimNames, checkBox)
            if (!checkBox) break
            estimFileNames.clear()
            i = 0
            estimNames.each { e ->
                if (checkBox[i]) estimFileNames.add(e)
                i++
            }
            if (!estimFileNames.isEmpty()) break
        }
    }

    def changeGlitches = {
        while (true) {
            txt = "Number of Glitches" +
                    "\n\n<p style='font-size: small';>Glitches in Classic Game Mode:"
            GLITCHES_CLASSIC.values().each { val ->
                txt += "\n" + val
            }
            txt += "\n\nGlitches in Retro Game Mode:"
            GLITCHES_RETRO.values().each { val ->
                txt += "\n" + val
            }
            txt += "</p>"
            String glitchesText = glitchesRange[0] + "-" + glitchesRange[1]
            String strGlitches = getString(txt, glitchesText)
            if (strGlitches.indexOf('-') >= 0) {
                List range = strGlitches.split('-').collect()
                if (range.size() == 2) {
                    def min = range[0]
                    def max = range[1]
                    if (min.isInteger() && max.isInteger()) {
                        min = min.toInteger()
                        max = max.toInteger()
                        if (min <= max) {
                            glitchesRange[0] = min
                            glitchesRange[1] = max
                            break
                        }
                    }
                }
            }
        }
    }

    def changeShockType = {
        while (true) {
            txt = "Shock Type:" +
                    "\n\n'single' shocks you with one waveform per shock." +
                    "\n\n'sequence' shocks with a sequence of random waveforms per shock." +
                    "\n\n(default: '" + SHOCKTYPES[0] + "')"
            int menu = getSelectedValue(txt, SHOCKTYPES)
            shockType = SHOCKTYPES[menu]
            break
        }
    }

    boolean bConf = true
    while (bConf) {
        initGame()
        drawStacks()
        txt = (retroGameMode) ? getParameterTextRetro() : getParameterTextClassic()
        int menu = getSelectedValue(txt, [
                "Number of Stacks",
                "Pain levels",
                "Shock time",
                "Wait time",
                "Pain levels random",
                "Shock time random",
                "Wait time random",
                "Pain levels hidden",
                "Chance to delay max Shocks",
                "Shock type",
                "eStim sound files",
                "Number of Glitches",
                "----------------",
                "Reset to default", // case ?
                "Save & Exit",
                "Exit"
        ])
        switch (menu) {
            case 0:
                changeNumStacks()
                break
            case 1:
                changePainLevelRange()
                break
            case 2:
                changeShockTimeRange()
                break
            case 3:
                changeWaitTimeRange()
                break
            case 4:
                changePainLevelRandom()
                break
            case 5:
                changeShockTimeRandom()
                break
            case 6:
                changeWaitTimeRandom()
                break
            case 7:
                changePainLevelHidden()
                break
            case 8:
                if (retroGameMode) {
                    show("Not in Retro Game Mode")
                    wait(2)
                } else changeChanceDelayMaxShock()
                break
            case 9:
                changeShockType()
                break
            case 10:
                changeEstimFileNames()
                break
            case 11:
                changeGlitches()
                break
        // no case ? ----------------
            case 13:
                if (getBoolean("Reset to default?")) resetDefault()
                break
            case 14: // Save & Exit
                saveConfig()
                bConf = false
                break
            case 15: // Exit
                bConf = false
                break
        }
    }

}

def getMinSessionTimeClassic = { int stacksToFill ->
    float time1 = 0.0
    float time2 = 0.0
    for (int n = 0; n < stacks.size(); n++) {
        for (int i = 0; i < (stacks[n].size() - 1); i++) {
            time1 += stacks[n][i][2] + stacks[n][i][3]
        }
        time2 += stacks[n][-1][2] + stacks[n][-1][3]
    }
    time1 = stacksToFill * (time1 / stacks.size())
    time2 = stacksToFill * (time2 / stacks.size())
    return (time1 + time2)
}

def getMaxSessionTimeClassic = { int stacksToFill ->
    float time1 = 0.0
    float time2 = 0.0
    for (int n = 0; n < stacks.size(); n++) {
        for (int i = 0; i < (stacks[n].size() - 1); i++) {
            time1 += stacks[n][i][2] + stacks[n][i][3]
        }
        time2 += stacks[n][-1][2] + stacks[n][-1][3]
    }
    time2 = stacksToFill * (time2 / stacks.size())
    return (time1 + time2)
}

def getMinSessionTimeRetro = {
    float sTime = numShocksToDo * shockTimeRange.min()
    float wTime = numShocksToDo * waitTimeRange.min()
    return (sTime + wTime)
}

def getMaxSessionTimeRetro = {
    float sTime = 0.0
    float wTime = 0.0
    stacks[0].each { st ->
        sTime += st[itemIndexShockTime]
        wTime += st[itemIndexWaitTime]
    }
    def stack = stacks[0]
    sTime += (numShocksToDo) * stack[-1][itemIndexShockTime]
    wTime += (numShocksToDo) * stack[-1][itemIndexWaitTime]
    return (sTime + wTime)
}


def showCountDown = { int countSec, String txt ->
    for (int c = countSec; c >= 0; c--) {
        show(String.format(txt, (int) (c / 60), (c % 60)))
        wait(1)
    }
}

def showCountDownClassic = {
    countDownMin = getInteger("Set countdown in minutes!", countDownMin)
    countDownSec = 60 * countDownMin
    String txtCountDown = "<b>status</b>" +
            "\n\n<span style='color: #696969';>waiting for signal</span>" +
            "\n\n<span style='color: red';>countdown to sequence: %02d:%02d</span>" +
            "\n\n<span style='color: #696969';>stacks filled: " + stacksFull + " of " + numStacksToFill +
            "\n\ncountdown to end" +
            "\n\nconcluded</span>"
    if (countDownMin == 0) countDownSec = 5
    String txtWait = "<b>status</b>" +
            "\n\n<span style='color: red';>waiting for signal</span>" +
            "\n\n<span style='color: #696969';>countdown to sequence: %02d:%02d</span>" +
            "\n\n<span style='color: #696969';>stacks filled: " + stacksFull + " of " + numStacksToFill +
            "\n\ncountdown to end" +
            "\n\nconcluded</span>"
    show(String.format(txtWait, (int) countDownMin, (countDownSec % 60)))
    showButton("Start Countdown")
    showCountDown(countDownSec, txtCountDown)
}

def showCountDownRetro = {
    countDownMin = getInteger("Set countdown in minutes!", countDownMin)
    countDownSec = 60 * countDownMin
    String txtCountDown = "<b>status</b>" +
            "\n\n<span style='color: #696969';>waiting for signal</span>" +
            "\n\n<span style='color: red';>countdown to sequence: %02d:%02d</span>" +
            "\n\n<span style='color: #696969';>shock sequence remaining: " + numShocksToDo +
            "\n\ncountdown to end" +
            "\n\nconcluded</span>"
    if (countDownMin == 0) countDownSec = 5
    String txtWait = "<b>status</b>" +
            "\n\n<span style='color: red';>waiting for signal</span>" +
            "\n\n<span style='color: #696969';>countdown to sequence: %02d:%02d" +
            "\n\nshock sequence remaining: " + numShocksToDo +
            "\n\ncountdown to end" +
            "\n\nconcluded</span>"
    show(String.format(txtWait, (int) countDownMin, (countDownSec % 60)))
    showButton("Start Countdown")
    showCountDown(countDownSec, txtCountDown)
}

def showOpenCDTray = {
    String txt = "Open CD tray to place a key?" +
            "\n\nSet a countdown to have time for placing the key." +
            "\n\n<b>Do not trust CD trays! Always have backups!</b>" +
            "\n\n<b>This is alpha software! Strict selfbondage is not recommended!</b>"
    openCDTray = getBoolean(txt)
    if (openCDTray) {
        openCdTrays()
        wait(2)
        countDownMin = 3
    }
}

def playTillStacksFull = { int stacksToFill ->
    drawStacks()

    stacksFull = 0
    if (stacksToFill > stacks.size()) stacksToFill = stacks.size()
    int colIndex = getRandom(stacks.size())
    int rowIndex = 0
    List stack = []
    boolean nearFull = false
    boolean shockStopped = false

    def getStatusText = {
        String txtStatus = "<b>status</b>" +
                "\n\n<span style='color: #696969';>waiting for signal" +
                "\n\ncountdown to sequence</span>" +
                "\n\n<span style='color: red';>stacks filled: " + stacksFull + " of " + numStacksToFill +
                "\n\n<span style='color: #696969';>countdown to end" +
                "\n\nconcluded</span>"
        return txtStatus
    }

    show(getStatusText())

    while (stacksFull < stacksToFill) {
        stack = stacks[colIndex]
        shockStopped = false

        // continue with next stack if last element in stack true
        if (stack[stack.size() - 1][0]) {
            colIndex = (colIndex + 1) % stacks.size()
            continue
        } else {
            colIndex = getRandom(stacks.size())
        }

        // chance to pick other stack, if stack nearly full
        if (!nearFull && stack.size() >= 2) {
            if (stack[-2][0] && getRandom(99) < chanceDelayMaxShock) {
                // test if all stacks are nearly full
                nearFull = true
                for (int i = 0; i < stacks.size(); i++) {
                    if (!stacks[i][-2][0]) {
                        nearFull = false
                        colIndex = i // not near full stack
                        break
                    }
                }
                if (!nearFull) continue
            }
        }

        // find row index not true in stack
        for (int i = 0; i < stack.size(); i++) {
            if (!stack[i][0]) {
                rowIndex = i
                break
            }
        }

        // vars
        painLevel = stack[rowIndex][itemIndexPainLevel]
        shockTime = stack[rowIndex][itemIndexShockTime]
        waitTime = stack[rowIndex][itemIndexWaitTime]
        float numShocksMulti = 1.0

        wait(waitTime)

        // glitches
        def glitch = stack[rowIndex][itemIndexGlitches]
        if (glitch) {
            if (DEBUG) show(GLITCHES_CLASSIC[glitch])
//            stack[rowIndex][itemIndexGlitches] = null
            switch (glitch) {
                case "stack_up":
                    stack[rowIndex][itemIndexDone] = true
                    drawStacks()
                    shockStopped = shock(shockTime, painLevel, canStopShock)
                    if (shockStopped) stack[rowIndex][itemIndexDone] = false
                    int stackHight = stack.size()
                    if (stack.size() < (3 + 1 + (painLevelRange[1] - painLevelRange[0]) / painLevelRange[2])) {
                        stacks.each { st ->
                            int plvl = stack[(stack.size() - 1)][itemIndexPainLevel]
                            float stime = stack[(stack.size() - 1)][itemIndexShockTime]
                            float wtime = stack[(stack.size() - 1)][itemIndexWaitTime]
                            st.add(getNewStackItem(plvl, stime, wtime))
                            // glitches
                            if (getRandom(100) > 50) {
                                if (glitchesRange.max() > (stacks.size() * stack.size())) {
                                    st[(st.size() - 1)][itemIndexGlitches] = GLITCHES_CLASSIC.keySet()[getRandom(GLITCHES_CLASSIC.size())]
                                }
                            }
                        }
                        initGraphics()
                        drawStacks()
                    }
                    break
                case "shock_not_count":
                    stack[rowIndex][itemIndexDone] = true
                    drawStacks()
                    shockStopped = shock(shockTime, painLevel, canStopShock)
                    stack[rowIndex][itemIndexDone] = false
                    colIndex = getRandom(stacks.size())
                    break
                case "flush_stack":
                    stack[rowIndex][itemIndexDone] = true
                    drawStacks()
                    shockStopped = shock(shockTime, painLevel, canStopShock)
                    if (shockStopped) stack[rowIndex][itemIndexDone] = false
                    for (int row = rowIndex; row >= 0; row--) {
                        stack[row][0] = false
                    }
                    break
                case "flush_highest_stacks":
                    stack[rowIndex][itemIndexDone] = true
                    drawStacks()
                    shockStopped = shock(shockTime, painLevel, canStopShock)
                    if (shockStopped) stack[rowIndex][itemIndexDone] = false
                    List highestStacks = []
                    for (int row = (stacks[0].size() - 1); row >= 0; row--) {
                        for (int col = 0; col < stacks.size(); col++) {
                            if (stacks[col][row][itemIndexDone]) {
                                highestStacks.add(col)
                            }
                        }
                        if (highestStacks.size() > 0) break
                    }
                    highestStacks.each { col ->
                        for (int row = (stacks[col].size() - 1); row >= 0; row--) {
                            stacks[col][row][itemIndexDone] = false
                        }
                    }
                    break
                case "add_stack":
                    stack[rowIndex][itemIndexDone] = true
                    drawStacks()
                    shockStopped = shock(shockTime, painLevel, canStopShock)
                    if (shockStopped) stack[rowIndex][itemIndexDone] = false
                    if (stacks.size() < MAXSTACKS && stacks.size() < (numStacks + 3)) {
                        List newStack = getNewStack()

                        int stacksMaxHeight = stacks[0].size()
                        stacks.each { st ->
                            if (stacksMaxHeight < stacks[0].size()) stacksMaxHeight = stacks[0].size()
                        }
                        stacks.add(newStack)

                        for (int i = newStack.size(); i < stacksMaxHeight; i++) {
                            int plvl = stack[(stack.size() - 1)][itemIndexPainLevel]
                            float stime = stack[(stack.size() - 1)][itemIndexShockTime]
                            float wtime = stack[(stack.size() - 1)][itemIndexWaitTime]
                            newStack.add(getNewStackItem(plvl, stime, wtime))
                        }
                        // glitches
                        if (glitchesRange.max() > (stacks.size() * stack.size())) {
                            newStack.each { it ->
                                if (getRandom(100) > 50) {
                                    it[itemIndexGlitches] = GLITCHES_CLASSIC.keySet()[getRandom(GLITCHES_CLASSIC.size())]
                                }
                            }
                        }
                        initGraphics()
                    }
                    break
                case "add_glitches":
                    stack[rowIndex][itemIndexDone] = true
                    drawStacks()
                    shockStopped = shock(shockTime, painLevel, canStopShock)
                    if (shockStopped) stack[rowIndex][itemIndexDone] = false
                    // glitches
                    List rndStackPos = []
                    for (int row = (stacks[0].size() - 1); row >= 0; row--) {
                        for (int col = 0; col < stacks.size(); col++) {
                            if (!stacks[col][row][itemIndexDone] && stacks[col][row][itemIndexGlitches] == null) {
                                rndStackPos.add([col, row])
                            }
                        }
                    }
                    if (rndStackPos.size() > 0) {
                        Collections.shuffle(rndStackPos)
                        int numGlitches = getRandom(3) + 1
                        if (numGlitches > rndStackPos.size()) numGlitches = rndStackPos.size()
                        for (int gl = 0; gl < numGlitches; gl++) {
                            int col = rndStackPos[gl][0]
                            int row = rndStackPos[gl][1]
                            stacks[col][row][itemIndexGlitches] = GLITCHES_CLASSIC.keySet()[getRandom(GLITCHES_CLASSIC.size())]
                        }
                    }
                    break
                case "lower_all_one":
                    stack[rowIndex][itemIndexDone] = true
                    drawStacks()
                    shockStopped = shock(shockTime, painLevel, canStopShock)
                    if (shockStopped) stack[rowIndex][itemIndexDone] = false
                    for (int col = 0; col < stacks.size(); col++) {
                        for (int row = (stacks[0].size() - 1); row >= 0; row--) {
                            if (row == (stacks[0].size() - 1) && stacks[col][row][itemIndexDone]) {
                                stacks[col][row][itemIndexDone] = false
                                break
                            } else {
                                if (stacks[col][row][itemIndexDone] && !stacks[col][row + 1][0]) {
                                    stacks[col][row][itemIndexDone] = false
                                    break
                                }
                            }
                        }
                    }
                    break
                case "random_painlevel":
                    int min = stack[rowIndex][itemIndexPainLevel]
                    int max = painLevelRange[0..1].max()
                    painLevel = getRandom((max - min + 1)) + min
                    stack[rowIndex][itemIndexPainLevel] = painLevel
                    stack[rowIndex][itemIndexDone] = true
                    drawStacks()
                    shockStopped = shock(shockTime, painLevel, canStopShock)
                    if (shockStopped) stack[rowIndex][itemIndexDone] = false
                    break
                case "random_shocktime":
                    int min = (int) (100 * stack[rowIndex][2])
                    int max = (int) (100 * shockTimeRange.max())
                    shockTime = (getRandom((max - min + 1)) + min) / 100
                    stack[rowIndex][2] = shockTime
                    stack[rowIndex][itemIndexDone] = true
                    drawStacks()
                    shockStopped = shock(shockTime, painLevel, canStopShock)
                    if (shockStopped) stack[rowIndex][itemIndexDone] = false
                    break
                case "random_shocknumber":
                    int min = 2
                    int max = 3
                    for (int i = 0; i < (getRandom((max - min + 1)) + min); i++) {
                        stack[rowIndex][itemIndexDone] = false
                        drawStacks()
                        wait(0.5)
                        stack[rowIndex][itemIndexDone] = true
                        drawStacks()
                        shockStopped = shock(shockTime, painLevel, canStopShock)
                        if (shockStopped) {
                            stack[rowIndex][itemIndexDone] = false
                            break
                        }
                    }
                    break
                case "repeat_stack":
                    stack.each { it -> it[itemIndexDone] = false }
                    for (int row = 0; row <= rowIndex; row++) {
                        stack[row][itemIndexDone] = true
                        drawStacks()
                        shockStopped = shock(SHOCKTIMERANGE.min(), stack[row][1], canStopShock)
                        if (shockStopped) break
                    }
                    if (shockStopped) stack.each { it -> it[itemIndexDone] = false }
                    break
                case "repeat_stack_backwards":
                    stack[rowIndex][itemIndexDone] = true
                    drawStacks()
                    for (int row = rowIndex; row >= 0; row--) {
                        stack[row][0] = false
                        shockStopped = shock(SHOCKTIMERANGE.min(), stack[row][1], canStopShock)
                        drawStacks()
                        if (shockStopped) break
                    }
                    if (shockStopped) stack.each { it -> it[itemIndexDone] = false }
                    break
            }
            if (!glitch in ["shock_not_count", "repeat_stack_backwards"]) {
                stack[rowIndex][itemIndexDone] = true // true = done
            }
            if (!shockStopped) stack[rowIndex][itemIndexGlitches] = null
            drawStacks()
            if (DEBUG) {
                wait(1)
                show(null)
            }
        } else {
            stack[rowIndex][itemIndexDone] = true // true = done
            drawStacks()
            shockStopped = shock(shockTime, painLevel, canStopShock)
            if (shockStopped) {
                stack[rowIndex][itemIndexDone] = false
                drawStacks()
            }
        }

        // count full stacks
        stacksFull = 0
        for (int n = 0; n < stacks.size(); n++) {
            if (stacks[n][(stacks[0].size() - 1)][0]) stacksFull++
        }

        show(getStatusText())
    }

    // countdown to end
    String txtStatus = "<b>status</b>" +
            "\n\n<span style='color: #696969';>waiting for signal" +
            "\n\ncountdown to sequence" +
            "\n\nstacks filled: " + stacksFull + " of " + numStacksToFill + "</span>" +
            "\n\n<span style='color: red';>countdown to end</span>" +
            "\n\n<span style='color: #696969';>concluded</span>"
    show(txtStatus)
    wait(waitTimeRange.min())
    txtStatus = "<b>status</b>" +
            "\n\n<span style='color: #696969';>waiting for signal" +
            "\n\ncountdown to sequence" +
            "\n\nstacks filled: " + stacksFull + " of " + numStacksToFill +
            "\n\ncountdown to end</span>" +
            "\n\n<span style='color: red';>concluded</span>"
    show(txtStatus)
}

def playTillShocksDone = { int shocks ->

    drawStacks()

    int shockCount = 0
    int shockRepeats = 1
    int colIndex = 0
    int rowIndex = 0
    float updateTime = 0.25 * waitTimeRange[0]
    List stack = []
    boolean shockStopped = false
    def glitch = null
    int numToSetTrue = 1
    float unfairPickChance = UNFAIRPICKCHANCE

    def getStatusText = {
        String txtStatus = "<b>status</b>" +
                "\n\n<span style='color: #696969';>waiting for signal" +
                "\n\ncountdown to sequence</span>" +
                "\n\n<span style='color: red';>shock sequence remaining: " + (shocks - shockCount) + "</span>" +
                "\n\n<span style='color: #696969';>countdown to end" +
                "\n\nconcluded</span>"
        return txtStatus
    }

    show(getStatusText())

    while (shockCount < shocks) {

        shockStopped = false
        glitch = null
        numToSetTrue = 1
        shockRepeats = 1

        // playing unfair
        int unfairColIndex = -1
        unfairPickChance += 1 / shocks * MAXUNFAIRPICKCHANCE
        if (getRandom(100) < unfairPickChance) {
            for (int row = (stacks[0].size() - 1); row >= 0; row--) {
                for (int col = 0; col < stacks.size(); col++) {
                    if (stacks[col][row][itemIndexDone]) {
                        unfairColIndex = col
                        break
                    }
                }
                if (unfairColIndex >= 0) break
            }
            unfairPickChance = UNFAIRPICKCHANCE // reset
            colIndex = unfairColIndex
        } else {
            colIndex = getRandom(stacks.size())
        }

        stack = stacks[colIndex]
        for (int row = (stack.size() - 1); row >= 0; row--) {
            if (stack[row][0]) {
                rowIndex = row
                break
            }
        }

        // vars
        glitch = stack[rowIndex][itemIndexGlitches]
        painLevel = stack[rowIndex][itemIndexPainLevel]
        shockTime = stack[rowIndex][itemIndexShockTime]
        waitTime = stack[rowIndex][itemIndexWaitTime]
        updateTime = waitTimeRange.min() * (getRandom(12) + 12) / 100

        // glitches
        switch (glitch) {
            case "shock_not_count":
                shockCount--
                break
            case "fill_stack":
                List notFullStackIndex = []
                stacks.eachWithIndex { Object st, int i ->
                    if (!st[(st.size() - 1)][0]) notFullStackIndex.add(i)
                }
                if (notFullStackIndex.size() > 0) {
                    Collections.shuffle(notFullStackIndex)
                    def rndCol = notFullStackIndex[0]
                    def rndStack = stacks[rndCol]
                    rndStack.each { it -> it[itemIndexDone] = true }
                }
                break
            case "increase_all_by_one":
                stacks.each { List st ->
                    for (int row = 0; row < (st.size() - 1); row++) {
                        if ((st[row][0] == true) && (st[row + 1][0] == false)) {
                            st[row + 1][0] = true
                            break
                        }
                    }
                }
                break
            case "add_glitches":
                List rndStackPos = []
                for (int row = (stacks[0].size() - 1); row >= 0; row--) {
                    for (int col = 0; col < stacks.size(); col++) {
                        if (!stacks[col][row][itemIndexDone] && stacks[col][row][itemIndexGlitches] == null) {
                            rndStackPos.add([col, row])
                        }
                    }
                }
                if (rndStackPos.size() > 0) {
                    Collections.shuffle(rndStackPos)
                    int numGlitches = getRandom(3) + 1
                    if (numGlitches > rndStackPos.size()) numGlitches = rndStackPos.size()
                    for (int gl = 0; gl < numGlitches; gl++) {
                        int col = rndStackPos[gl][0]
                        int row = rndStackPos[gl][1]
                        stacks[col][row][itemIndexGlitches] = GLITCHES_RETRO.keySet()[getRandom(GLITCHES_RETRO.size())]
                    }
                }
                break
            case "increase_random_stacks":
                int min = 2
                int max = 3
                numToSetTrue = getRandom((max - min + 1)) + min
                break
            case "random_painlevel":
                int min = stack[rowIndex][itemIndexPainLevel]
                int max = painLevelRange[0..1].max()
                painLevel = getRandom((max - min + 1)) + min
                stack[rowIndex][itemIndexPainLevel] = painLevel
                break
            case "random_shocktime":
                int min = (int) (100 * stack[rowIndex][itemIndexShockTime])
                int max = (int) (100 * shockTimeRange.max())
                shockTime = (getRandom((max - min + 1)) + min) / 100
                stack[rowIndex][itemIndexShockTime] = shockTime
                break
            case "random_shocknumber":
                int min = 2
                int max = 3
                shockRepeats = getRandom((max - min + 1)) + min
                break
            case "random_wait_time":
                int min = (int) (100 * waitTimeRange.min())
                int max = (int) (100 * stack[rowIndex][itemIndexWaitTime])
                waitTime = (getRandom((max - min + 1)) + min) / 100
                stack[rowIndex][itemIndexWaitTime] = waitTime
                break
        }

        stack[rowIndex][itemIndexGlitches] = null // remove glitch

        if (DEBUG) {
            def txtDebug = getStatusText() +
                    "\n\nDEBUG: next shock" +
                    "\npainLevel ......... " + painLevel +
                    "\nshockTime ......... " + shockTime +
                    "\nwaitTime .......... " + waitTime +
                    "\nupdateTime ........ " + updateTime +
                    "\nglitch ............ " + glitch +
                    "\nunfairPickChance .. " + unfairPickChance
            show(txtDebug)
        }

        wait(waitTime - updateTime)

        // shock
        for (int s = 0; s < shockRepeats; s++) {
            shockStopped = shock(shockTime, painLevel, canStopShock)
            if (shockStopped) break
        }
        if (shockStopped) {
            int shocksToAdd = 1
            if (rowIndex <= (1 / 3 * stack.size())) shocksToAdd = 3
            else if (rowIndex > (1 / 3 * stack.size()) && rowIndex <= (2 / 3 * stack.size())) shocksToAdd = 2
            shockCount -= shocksToAdd
        } else shockCount++


        // update
        if (shockCount < shocks) {
            wait(updateTime)
            if (!(glitch in ["fill_stack", "increase_all_by_one"])) {
                List notFullStackIndex = []
                stacks.eachWithIndex { Object st, int i ->
                    if (!st[(st.size() - 1)][0]) notFullStackIndex.add(i)
                }
                if (notFullStackIndex.size() >= numToSetTrue) {
                    Collections.shuffle(notFullStackIndex)
                    for (int i = 0; i < numToSetTrue; i++) {
                        def rndCol = notFullStackIndex[i]
                        def rndStack = stacks[rndCol]
                        for (int row = (rndStack.size() - 1); row >= 0; row--) {
                            if (rndStack[row][0] && row < (rndStack.size() - 1)) {
                                rndStack[row + 1][0] = true
                                break
                            }
                        }
                    }
                }
            }
        }

        drawStacks()
        show(getStatusText())
    }

    // countdown to end
    String txtStatus = "<b>status</b>" +
            "\n\n<span style='color: #696969';>waiting for signal" +
            "\n\ncountdown to sequence" +
            "\n\nshock sequence remaining: 0</span>" +
            "\n\n<span style='color: red';>countdown to end</span>" +
            "\n\n<span style='color: #696969';>concluded</span>"
    show(txtStatus)
    wait(waitTimeRange.min())
    txtStatus = "<b>status</b>" +
            "\n\n<span style='color: #696969';>waiting for signal" +
            "\n\ncountdown to sequence" +
            "\n\nshock sequence remaining: 0" +
            "\n\ncountdown to end</span>" +
            "\n\n<span style='color: red';>concluded</span>"
    show(txtStatus)
}

def showGameModeClassicIntro = {
    retroGameMode = false
    String txtTitle = "<span style='font-size: xx-large';')>Pain Stacks <i>Classic</i></span>\n\n"
    String txt = ""

    initGame()
    drawStacks()

    def setParameters = {
        openCDTray = false
        initGame()
        drawStacks()
        while (true) {
            txt = "How many stacks have to be full to end the game?"
            if (numStacksToFill > numStacks) txt += "\n\nNumber needs to be smaller or equal to number of stacks."
            numStacksToFill = getInteger(txt, numStacksToFill)
            if (numStacksToFill >= 1 && numStacksToFill <= numStacks) break
        }
    }

    def showSessionTime = {
        int minSTime = (int) Math.round(getMinSessionTimeClassic(numStacksToFill) / 60)
        int maxSTime = (int) Math.round(getMaxSessionTimeClassic(numStacksToFill) / 60)
        txt = "The session will be between " + minSTime + " and " + maxSTime + " minutes."
        if (glitchesRange.max() > 0) txt += "\n\n<b>Glitches can make sessions longer!</b>"
        show(txt)
    }

    boolean start = false
    while (!start) {
        txt = txtTitle + getParameterTextClassic()
        int menu = getSelectedValue(txt, ["Start", "Config", "Back"])
        if (menu == 0) {
            setParameters()
            showSessionTime()
            if (getBoolean(null, "Continue", "Back")) start = true
        } else if (menu == 1) {
            changeConfig()
        } else if (menu == 2) {
            return false
        }
    }

    if (start) {
        showOpenCDTray()
        showCountDownClassic()
        playTillStacksFull(numStacksToFill)
        if (openCDTray) openCdTrays()
        showButton("End")
    }
}

def showGameModeRetroIntro = {
    retroGameMode = true
    String txtTitle = "<span style='font-size: xx-large';')>Pain Stacks <i>Classic</i></span>\n\n"
    String txt = ""

    initGame()
    drawStacks()

    def setParameters = {
        openCDTray = false
        initGame()
        drawStacks()
        while (true) {
            int max = numStacks + numStacks * (painLevelRange[1] - painLevelRange[0]) / painLevelRange[2]
            txt = "How many shocks to end the game? (max. " + max + ")"
            numShocksToDo = Math.min(numShocksToDo, max)
            numShocksToDo = getInteger(txt, numShocksToDo)
            if (numShocksToDo >= 1 && numShocksToDo <= max) break
        }
    }

    def showSessionTime = {
        int minSTime = (int) Math.round(getMinSessionTimeRetro() / 60)
        int maxSTime = (int) Math.round(getMaxSessionTimeRetro() / 60)
        txt = "The session will be between " + minSTime + " and " + maxSTime + " minutes."
        if (glitchesRange.max() > 0) txt += "\n\n<b>Glitches can make sessions longer!</b>"
        show(txt)
    }
    boolean start = false
    while (!start) {
        txt = txtTitle + getParameterTextClassic()
        int menu = getSelectedValue(txt, ["Start", "Config", "Back"])
        if (menu == 0) {
            setParameters()
            showSessionTime()
            if (getBoolean(null, "Continue", "Back")) start = true
        } else if (menu == 1) {
            changeConfig()
        } else if (menu == 2) {
            return false
        }
    }

    if (start) {
        showOpenCDTray()
        showCountDownRetro()
        playTillShocksDone(numShocksToDo)
        if (openCDTray) openCdTrays()
        showButton("End")
    }
}

def showIntro = {
    setImage(null)
    retroGameMode = false
    String txt = "<span style='font-size: xx-large';')>Pain Stacks</span>\n\n" +
            "Sessions can be very long!\nStrict selfbondage is not recommended!" +
            "\n\nTest and calibrate eStim first!" +
            "\n\n\nSelect Game Mode:" +
            "\n\nIn Classic you play till a set number of stacks are full." +
            "\n\nIn Retro you play till you got a set number of shocks."

    int menu = getSelectedValue(show(txt), ["Classic", "Retro", "Test eStim"])
    if (menu == 0) {
        while (showGameModeClassicIntro()) {
        }
    } else if (menu == 1) {
        while (showGameModeRetroIntro()) {
        }
    } else if (menu == 2) testEstim()

}

show(null)
setImage(null)
loadConfig()
while (true) {
    playBackgroundSound(null)
    showIntro()
}

/*
 * Resources
 * scripts/PainStacks.groovy
 * images/PainStacks/*.png
 */
